#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <cmath>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>

using namespace std;

//  Input   
struct Input
{
    vector<double> Numbers;
    size_t bin_count{};
};

// 
Input input_data(istream& in, bool prompt)
{
    size_t number_count;
    Input stct;
    //   
    if (prompt)
    {
        cerr << "Enter number count ";
    }
    in >> number_count;
    // 
    vector<double> Numbers(number_count);
    stct.Numbers.resize(number_count);
    if (prompt)
    {
        cerr << "Enter array:\n";
    }
    in >> stct.Numbers[0];
    for (int i = 1; i < number_count; i++)
    {
        in >> stct.Numbers[i];
    }
    //  
    if (prompt)
    {
        cerr << "Enter bin count\n";
    }
    in >> stct.bin_count;
    // 
    return stct;
}

int main()
{
    curl_global_init(CURL_GLOBAL_ALL);

    //    
    auto in = input_data(cin, true);

    //  bins  
    vector<size_t> bins = make_histogram(in.Numbers, in.bin_count);

    // 
    show_histogram_svg(bins);
    //show_histogram_text(bins);

    return 0;
}
